#include "noise.h"

double Gauss::logLratio(int y, double t1, double t0) const
{
    double c = (t1 + t0)/2.0;
    double scale = (t1 - t0)/var;

    return( scale * (y-c) );
}

double Gauss::logCanonic(int y, double t) const
{
   return ( - ( ( y - t ) * ( y - t ) )  / ( 2.0 * var ) );
}

double
clip( int y, double a, double b )  // assume a <= b
{
   if( y < a ) return a;
   if( y > b ) return b;
   return y;
}

double Laplace::logLratio(int y, double t1, double t0) const
{
   double c = (t1 + t0)/2.0;
   return ( (t0<t1) ? 2*disp*( clip(y,t0,t1) - c) :
                     -2*disp*( clip(y,t1,t0) - c) );

}

double Laplace::logCanonic(int y, double t) const
{
   return ( - disp * fabs( y - t )  );
}

