#ifndef _pattern_
#define _pattern_ 1

#include "event.h"
#include "vector.h"
#include <iostream>
// using namespace std;
#include <cstdio>
#include <cmath>
#include <clip.bin.h>


class Pattern: public Vector {
 public:
   Pattern( int init_capacity = 50 );

   EventPointer getEvent( int k ) const
      { return (EventPointer) get(k); }
   EventPointer position_rmv( int k );
   void position_add( EventPointer e, int k );

   void destroy();
};


// typedef IndexPointer *int;

class IntVal {
 public:
   IntVal( int i ) { id = i; }
   int id;
};

typedef IntVal * IntValPointer;


class VectorInt: public Vector {
  public:
   VectorInt( int init_capacity = 50 );
   IntValPointer operator[] ( int i ) 
      { return (IntValPointer) get(i); }
   void destroy();
};

class TransitionList;

class Transition {
 private:
   Transition *prev;
 public:
   Event *e;	// event that is deleted or added
   int pos;     // position in sequence of *e
   double t;	// transition time
   double w;	// storage of reusable random number
   short is_birth; // forward transition indicator

   Transition( Event *e, int pos, double t, short is_birth, double w );
   virtual ~Transition() { }
   Transition *getPrevious() { return prev; }
   friend class TransitionList;
};

class PermuteTransition: public Transition {
 public:
   Event *u;	// event that is deleted or added to U
   Event *l;    // event that is deleted or added to L
   Pattern L;  // L restricted to updated cell

   PermuteTransition( Event *e, int pos, double t, short is_birth, double w );
   ~PermuteTransition();
   void setPreviousEvents( Event *eUp, Event *eLp, Pattern Lp);
};

class TransitionList {
 private:
   Transition* last;
   int size;
   //Pattern T;        
 public:
   TransitionList() { last = NULL; size = 0; }
   // void setPattern( Pattern &cT) { T = cT; }
   void add( Transition *t ) { t->prev = last; last = t; size++; }
   Transition* getLast() const { return last; }
   int getSize() const { return size; }
   void destroy();
};

// endif _event_
#endif
