#include "prior.h"

Prior::Prior( double cK, double cw, double ch )
{
   K = cK; 
   width = cw; height = ch; 
}

void Prior::printInit( char *name_par, char *name_stats, char *name_pat )
{
   if( (par_file=fopen(name_par,"at")) == NULL ) {
      std::cout << "ERROR : opening file in printInit()";
      std::cout << name_par << " \n";
      exit(1);
   }

   if( (stats_file=fopen(name_stats,"at")) == NULL ) {
      std::cout << "ERROR : opening file in printInit()";
      std::cout << name_stats << " \n";
      exit(1);
   }

   if( (pat_file=fopen(name_pat,"at")) == NULL ) {
      std::cout << "ERROR : opening file in printInit()";
      std::cout << name_pat << " \n";
      exit(1);
   }
}

void Prior::printClose()
{
   fclose(par_file);
   fclose(stats_file);
   fclose(pat_file);
}

void Prior::printParameters( ) 
{
   fprintf(par_file, "%f \n", ubnd());
   fflush(par_file);
}

void Prior::printSample( const Pattern& p ) 
{
   int sz = p.getSize();
   if( sz > 0 ) {
      for( int i=0; i<sz; i++ ) 
         fprintf(pat_file, "%f %f \n", 
	    p.getEvent(i)->getX(), p.getEvent(i)->getY());
 
   }
   fprintf(pat_file, "\n");
   fflush(pat_file); 
}

void Prior::printStatistics( const Pattern& p ) 
{
   fprintf(stats_file, "%d\n", getTotal(p));
   fflush(stats_file); 
}

int Prior::getTotal(const Pattern& p) const
{
   return p.getSize();
}

EventPointer Prior::newEvent() const
{
   return( new Event( width*whrg.uniform(), height*whrg.uniform() ) );
}

