#include "signal.h"

Occlusion::Occlusion( int width, int height, int cbg )
{
      colour = (ipGrey) newImage( width, height );
      colour <<= cbg;
      bg = cbg;
}

void Occlusion::add( const Pattern& p, const Object *u, int i )
{
   if( i > p.getSize() || i < 0 ) {
      std::cout << "Occlusion: illegal insertion\n";
      exit(1);
   }

   Object *e;
   FOR( q in u->shape() ) {
      if( colour.has(q) ) colour(q) = u->getColour();
      for( int k=i; k>0; k-- ) {
         e = (Object *) p.getEvent(k-1);
         if( colour.has(q) && e->contains(q) ) colour(q) = e->getColour();
      }
   }
}

void Occlusion::del( const Pattern& p, int i )
{
   if( i > p.getSize() - 1 || i < 0 ) {
      std::cout << "Occlusion: illegal insertion\n";
      exit(1);
   }

   Object *e;
   Object *u = (Object *) p.getEvent(i);
   FOR( q in u->shape() ) {
      if( colour.has(q) ) colour(q) = bg;
      for( int k=p.getSize(); k>0; k-- ) {
         e = (Object *) p.getEvent(k-1);
         if( colour.has(q) && e->contains(q) ) {
             if( k != i+1 ) colour(q) = ( (Object *) p.getEvent(k-1) )->getColour();
         }
      }
   }
}
