#ifndef _signal_
#define _signal_ 1

/*
	Signal		signal model
			- typically maintains current signal
			- rules for determining the effect on signal
			  of adding/deleting an object 
*/

#include <clip.short.h>
#include <clip.float.h>
#include <clip.grey.h>
#include "pattern.h"

class Signal {
public:
      // operations to maintain `current signal' in single image frame
   virtual void add( const Pattern&, const Object *, int ) = 0;
   virtual void del( const Pattern&, int ) = 0;

   virtual double val( point ) const = 0;
   virtual void report() const = 0;
};

class Occlusion : public Signal {
   ipGrey colour;         // colour of object determining the signal
   int bg;
public:
   Occlusion( int width, int height, int cbg );
     // bg = background colour

   void add( const Pattern& p, const Object *u, int i );
   void del( const Pattern& p, int i );

   double val( point p ) const { return colour(p); }
   double getBackground() const { return bg; }
   ipGrey getImage() const { return colour; }

   void report() const {
       std::cout << "Blur-free grey level signal with occlusion\n";
   }
};

#endif
