#include <cstdlib>
#include <cstdio>
#include <clip.grey.h>
#include <clip.float.h>
#include <clip.int.h>

#include "state.h"

ipGrey 
redcomponent( ipInt a )
{
   ipGrey b = newImage( a.width(), a.height() );
   WITH( a, b ) b = a & 0xff;

// 0xff = 255, i.e. all 1's.
   return b;
}

ipGrey 
greencomponent( ipInt a )
{
   ipGrey b = newImage( a.width(), a.height() );
   WITH( a, b ) b = (a>>8) & 0xff;
   return b;
}

ipGrey 
bluecomponent( ipInt a )
{
   ipGrey b = newImage( a.width(), a.height() );
   WITH( a, b ) b = (a>>16) & 0xff;
   return b;
}

int main(int argc, char *argv[])
{
   if( argc < 2 ) {
     fprintf( stderr, "usage: %s beta \n", argv[0] );
     exit(1);
   }

/*
ipGrey red;
ipGrey green;
ipGrey blue;

read_tiff( red, green, blue, "miamiclip0.tiff" );

clipWindow rwin("miami red", red.width(), red.height() );
clipWindow gwin("miami green", green.width(), green.height() );
clipWindow bwin("miami blue", blue.width(), blue.height() );

rwin.display( red );
iwait();
gwin.display( green );
iwait();
bwin.display( blue );
iwait();

write_tiff( red, green, blue, "rgb.tiff" );

ipInt miami = newImage( red.width(), red.height() );
WITH( red, green, blue, miami ) 
   miami = red + ( green<<8 ) + ( blue<<16 );

clipWindow mwin("test", blue.width(), blue.height() );
mwin.display( miami );
iwait();

red = redcomponent( miami );
mwin.display( red );
iwait();
green = greencomponent( miami );
mwin.display( green );
iwait();
blue = bluecomponent( miami );
mwin.display( blue );
iwait();


return(1);

*/
   ipShort pic1 = read_tiff("squares3.tiff");
   std::cerr << "max " << sup(pic1) << " en min " << inf(pic1) << "\n";
   ipShort pic2 = read_tiff("squares5.tiff");
   std::cerr << "max " << sup(pic2) << " en min " << inf(pic2) << "\n";
   ipShort pic3 = read_tiff("squares7.tiff");
   std::cerr << "max " << sup(pic3) << " en min " << inf(pic3) << "\n";
   ipShort pic4 = read_tiff("squares9.tiff");
   std::cerr << "max " << sup(pic4) << " en min " << inf(pic4) << "\n";

   clipWindow iwin("input", 100, 100);
   iwin.display(pic1, 255, 0);
   iwait();

   iwin.display(pic2, 255, 0);
   iwait();

   iwin.display(pic3, 255, 0);
   iwait();

   iwin.display(pic4, 255, 0);
   iwait();

   whrg.setSeed(123,456,789);

   Noise *karl = new Gauss( 128*128 );
   karl->report();

   SquareStrauss *richard = new SquareStrauss( -10.0, -50.0,
       100.0, 100.0, 256, 0, 45.0, 15.0, 50.0 );
   richard->report();

   Pattern pat;

   Occlusion *sil1 = new Occlusion( 100, 100, 0 );
   Occlusion *sil2 = new Occlusion( 100, 100, 0 );
   Occlusion *sil3 = new Occlusion( 100, 100, 0 );
   Occlusion *sil4 = new Occlusion( 100, 100, 0 );

   FrameState *frames = new FrameState[4];
   (frames[0]).data = pic1; (frames[0]).pat = pat; (frames[0]).sil = sil1;
   (frames[1]).data = pic2; (frames[1]).pat = pat; (frames[1]).sil = sil2;
   (frames[2]).data = pic3; (frames[2]).pat = pat; (frames[2]).sil = sil3;
   (frames[3]).data = pic4; (frames[3]).pat = pat; (frames[3]).sil = sil4;

   State *video = new State( frames, 4, karl, richard );
   video->report();
   iwait();

//   video->iter(50000,  1.0);

if(0) {
   Square *tob = new Square( 69, 9, 20, 128 );
   video->add( tob, 0, 0 );
   tob = new Square( 0, 0, 39, 255 );
   video->add( tob, 0, 1 );

   tob = new Square( 9, 9, 40, 255 );
   video->add( tob, 1, 0 );
   tob = new Square( 59, 19, 20, 128 );
   video->add( tob, 1, 1 );

   tob = new Square( 49, 29, 20, 128 );
   video->add( tob, 2, 0 );
   tob = new Square( 19, 19, 40, 255 );
   video->add( tob, 2, 1 );

   tob = new Square( 39, 39, 20, 128 );
   video->add( tob, 3, 0 );
   tob = new Square( 29, 29, 40, 255 );
   video->add( tob, 3, 1 );

   frames = video->getState();
   VideoObject *ob1 = (VideoObject *) (frames[0].pat).getEvent( 0 );
   VideoObject *ob2 = (VideoObject *) (frames[1].pat).getEvent( 1 );
   video->add_link( ob1, ob2 );
   ob1 = (VideoObject *) (frames[0].pat).getEvent( 1 );
   ob2 = (VideoObject *) (frames[1].pat).getEvent( 0 );
   video->add_link( ob1, ob2 );

   ob1 = (VideoObject *) (frames[1].pat).getEvent( 0 );
   ob2 = (VideoObject *) (frames[2].pat).getEvent( 1 );
   video->add_link( ob1, ob2 );
   ob1 = (VideoObject *) (frames[1].pat).getEvent( 1 );
   ob2 = (VideoObject *) (frames[2].pat).getEvent( 0 );
   video->add_link( ob1, ob2 );

   ob1 = (VideoObject *) (frames[2].pat).getEvent( 0 );
   ob2 = (VideoObject *) (frames[3].pat).getEvent( 0 );
   video->add_link( ob1, ob2 );
   ob1 = (VideoObject *) (frames[2].pat).getEvent( 1 );
   ob2 = (VideoObject *) (frames[3].pat).getEvent( 1 );
   video->add_link( ob1, ob2 );

}

if(1) {
   Square *tob = new Square( 69.1541, 8.80419, 20.3946, 120 );
   video->add( tob, 0, 0 );
   tob = new Square( 0.182758, 0.00702062, 39.2445, 253 );
   video->add( tob, 0, 1 );

   tob = new Square( 9.24703, 8.65648, 39.7897, 252 );
   video->add( tob, 1, 0 );
   tob = new Square( 58.7431, 18.6711, 20.2395, 133 );
   video->add( tob, 1, 1 );

   tob = new Square( 49.351, 28.5565, 19.5882, 134 );
   video->add( tob, 2, 0 );
   tob = new Square( 19.0953, 19.1018, 40.3016, 250 );
   video->add( tob, 2, 1 );

   tob = new Square( 40.1611, 39.1348, 20.475, 139 );
   video->add( tob, 3, 0 );
   tob = new Square( 28.6302, 28.7953, 40.2764, 253 );
   video->add( tob, 3, 1 );

   frames = video->getState();
   VideoObject *ob1 = (VideoObject *) (frames[0].pat).getEvent( 0 );
   VideoObject *ob2 = (VideoObject *) (frames[1].pat).getEvent( 1 );
   video->add_link( ob1, ob2 );
   ob1 = (VideoObject *) (frames[0].pat).getEvent( 1 );
   ob2 = (VideoObject *) (frames[1].pat).getEvent( 0 );
   video->add_link( ob1, ob2 );

   ob1 = (VideoObject *) (frames[1].pat).getEvent( 0 );
   ob2 = (VideoObject *) (frames[2].pat).getEvent( 1 );
   video->add_link( ob1, ob2 );
   ob1 = (VideoObject *) (frames[1].pat).getEvent( 1 );
   ob2 = (VideoObject *) (frames[2].pat).getEvent( 0 );
   video->add_link( ob1, ob2 );

   ob1 = (VideoObject *) (frames[2].pat).getEvent( 0 );
   ob2 = (VideoObject *) (frames[3].pat).getEvent( 0 );
   video->add_link( ob1, ob2 );
   ob1 = (VideoObject *) (frames[2].pat).getEvent( 1 );
   ob2 = (VideoObject *) (frames[3].pat).getEvent( 1 );
   video->add_link( ob1, ob2 );

   video->set_Hamiltonian( 229.375 );
}
   std::cerr << "Now I am going to apply the annealing algorithm\n";
for( int anneal = 0; anneal < 1000; anneal++ ) {
   video->iter( 50, 1.0 / ( 1 + 0.005*anneal) ); 
 std::cout << "temperature = " << 1.0 / ( 1 + 0.005*anneal) << "\n";

   video->report_all();
   std::cout << "Hamiltonian: " << video->report_Hamiltonian() << "\n";
   std::cout << "Hamiltonian by potential: " << video->potential() << "\n";

   std::cout << "nops = " << nops << "\n";
   std::cout << "nop_del = " << nop_del << "\n";
   std::cout << "nop_new = " << nop_new << "\n";

   frames = video->getState();
   sil1 = (Occlusion *) (frames[0]).sil;
   sil2 = (Occlusion *) (frames[1]).sil;
   sil3 = (Occlusion *) (frames[2]).sil;
   sil4 = (Occlusion *) (frames[3]).sil;
   iwin.display( sil1->getImage(), 255, 0);
   //iwait();
   iwin.display( sil2->getImage(), 255, 0);
   //iwait();
   iwin.display( sil3->getImage(), 255, 0);
   //iwait();
   iwin.display( sil4->getImage(), 255, 0);
   //iwait();

/*
if(video->report_Hamiltonian() < 195 ) {
  std::cout << "temperature = " << 1.0 / ( 1 + 0.05*anneal) << "\n";
  std::cout << "anneal = " << anneal << "\n";
  exit(1);
}
*/
}
   return(1);
}
