#ifndef _sc_
#define _sc_ 1


#include "prior.h"
#include "mesevent.h"

class Softcore : public Prior {
   double gamma, mu;
 public:
   Softcore( double cb, double cg, double cm, double cw, double ch );
   double cond_intens( const Pattern& p, const Event *e, int i ) const;
   int monotone() const;
   double getGamma() const { return gamma; }
   double getMu() const { return mu; }
   void setParameters( double cb, double cg, double cm );
   int getInteractingPairs( const Pattern& p ) const;
      // sum_{i<j} 1{ || x_i - x_j || <= m_i }
   void report() const;
   virtual void printParameters();
      // by default the ubnd
   virtual void printSample( const Pattern& p );
   virtual void printStatistics( const Pattern& p );
   Event *newEvent() const;
};


#endif
